# Contributing to CleverHans

First off, thank you for considering contributing to CleverHans.
Following these guidelines helps to communicate that you respect
the time of the researchers and developers managing and developing this open
source project. In return, they should reciprocate that respect in
addressing your issue, assessing changes, and helping you finalize
your pull requests.

Adding new features, improving documentation, bug triaging, or
writing tutorials are all
examples of helpful contributions.
Furthermore, if you are publishing a new attack or defense,
we strongly encourage you to add it to CleverHans so that others
may evaluate it fairly in their own work.

To speed the code review process, we ask that:

* New efforts and features be coordinated
on the mailing list for CleverHans development: [cleverhans-dev@googlegroups.com](https://groups.google.com/forum/#!forum/cleverhans-dev).
* When making code contributions to CleverHans, you should follow the
[`Black`](https://black.readthedocs.io/en/stable/index.html) coding style in your pull requests.
* We do not accept pull requests that add git submodules because of [the
  problems that arise when maintaining git
  submodules](https://medium.com/@porteneuve/mastering-git-submodules-34c65e940407)

Bug fixes can be initiated through Github pull requests.
